(function (_, kotlin_clikt_clikt, kotlin_kotlin, kotlin_mordant_mordant) {
  'use strict';
  //region block: imports
  var CoreCliktCommand = kotlin_clikt_clikt.$_$.a;
  var VOID = kotlin_kotlin.$_$.g;
  var Unit_instance = kotlin_kotlin.$_$.h3;
  var protoOf = kotlin_kotlin.$_$.p8;
  var initMetadataForClass = kotlin_kotlin.$_$.q7;
  var selfAndAncestors = kotlin_clikt_clikt.$_$.e;
  var mapNotNull = kotlin_kotlin.$_$.q9;
  var firstOrNull = kotlin_kotlin.$_$.l9;
  var Terminal_init_$Create$ = kotlin_mordant_mordant.$_$.g;
  var last = kotlin_kotlin.$_$.p9;
  var MultiplatformSystem_instance = kotlin_mordant_mordant.$_$.i;
  var FileNotFound = kotlin_clikt_clikt.$_$.b;
  var Terminal = kotlin_mordant_mordant.$_$.b;
  var Whitespace_NORMAL_getInstance = kotlin_mordant_mordant.$_$.e;
  var Text_init_$Create$ = kotlin_mordant_mordant.$_$.h;
  var AbstractHelpFormatter = kotlin_clikt_clikt.$_$.g;
  var verticalLayout = kotlin_mordant_mordant.$_$.a;
  var charSequenceLength = kotlin_kotlin.$_$.g7;
  var definitionList = kotlin_mordant_mordant.$_$.c;
  var withPadding = kotlin_mordant_mordant.$_$.d;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.e4;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.k;
  var ensureNotNull = kotlin_kotlin.$_$.oc;
  var drop = kotlin_kotlin.$_$.ba;
  var plus = kotlin_kotlin.$_$.uc;
  var Whitespace_PRE_WRAP_getInstance = kotlin_mordant_mordant.$_$.f;
  var isBlank = kotlin_kotlin.$_$.ia;
  var replace = kotlin_kotlin.$_$.ua;
  //endregion
  //region block: pre-declaration
  initMetadataForClass(CliktCommand, 'CliktCommand', VOID, CoreCliktCommand);
  initMetadataForClass(MordantHelpFormatter, 'MordantHelpFormatter', VOID, AbstractHelpFormatter);
  //endregion
  function CliktCommand(name) {
    name = name === VOID ? null : name;
    CoreCliktCommand.call(this, name);
    installMordant(this);
  }
  function installMordant(_this__u8e3s4, force) {
    force = force === VOID ? false : force;
    _this__u8e3s4.x1h(installMordant$lambda(force));
  }
  function get_terminal(_this__u8e3s4) {
    // Inline function 'com.github.ajalt.clikt.core.Context.findObject' call
    var key = 'mordant_terminal';
    var tmp = selfAndAncestors(_this__u8e3s4);
    var tmp0_elvis_lhs = firstOrNull(mapNotNull(tmp, _get_terminal_$lambda_5keric(key)));
    var tmp_0;
    if (tmp0_elvis_lhs == null) {
      // Inline function 'kotlin.also' call
      var this_0 = Terminal_init_$Create$();
      // Inline function 'com.github.ajalt.clikt.core.<get-terminal>.<anonymous>' call
      var tmp0 = last(selfAndAncestors(_this__u8e3s4)).v1f_1;
      // Inline function 'kotlin.collections.set' call
      var key_0 = 'mordant_terminal';
      tmp0.e2(key_0, this_0);
      tmp_0 = this_0;
    } else {
      tmp_0 = tmp0_elvis_lhs;
    }
    return tmp_0;
  }
  function installMordant$lambda$lambda(it) {
    return new MordantHelpFormatter(it);
  }
  function installMordant$lambda$lambda_0(it) {
    return MultiplatformSystem_instance.s23(it);
  }
  function installMordant$lambda$lambda_1(it) {
    var tmp0_elvis_lhs = MultiplatformSystem_instance.u23(it);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      throw new FileNotFound(it);
    } else {
      tmp = tmp0_elvis_lhs;
    }
    return tmp;
  }
  function installMordant$lambda$lambda_2(it) {
    MultiplatformSystem_instance.t23(it);
    return Unit_instance;
  }
  function installMordant$lambda$lambda_3(context, message, trailingNewline, err) {
    if (trailingNewline) {
      get_terminal(context).s2d(message, VOID, VOID, VOID, VOID, err);
    } else {
      get_terminal(context).q2d(message, VOID, VOID, VOID, VOID, err);
    }
    return Unit_instance;
  }
  function installMordant$lambda($force) {
    return function ($this$configureContext) {
      var tmp;
      if (!$force && !($this$configureContext.y1h_1 == null)) {
        return Unit_instance;
      }
      var tmp_0 = $this$configureContext;
      tmp_0.d1i_1 = installMordant$lambda$lambda;
      var tmp_1 = $this$configureContext;
      tmp_1.l1i_1 = installMordant$lambda$lambda_0;
      var tmp_2 = $this$configureContext;
      tmp_2.g1i_1 = installMordant$lambda$lambda_1;
      var tmp_3 = $this$configureContext;
      tmp_3.o1i_1 = installMordant$lambda$lambda_2;
      var tmp_4 = $this$configureContext;
      tmp_4.n1i_1 = installMordant$lambda$lambda_3;
      return Unit_instance;
    };
  }
  function _get_terminal_$lambda_5keric($key) {
    return function (it) {
      var tmp = it.v1f_1.w1($key);
      return tmp instanceof Terminal ? tmp : null;
    };
  }
  function MordantHelpFormatter$formatHelp$lambda(this$0, $error, $prolog, $epilog, $parameters, $programName) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.i2a(1);
      $this$verticalLayout.f2a(this$0.g1o($error, $prolog, $epilog, $parameters, $programName));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderUsage$lambda($prog, $usageParts) {
    return function ($this$definitionList) {
      $this$definitionList.c2e($prog, Text_init_$Create$($usageParts, Whitespace_NORMAL_getInstance()));
      $this$definitionList.w2d_1 = true;
      $this$definitionList.z2d(1);
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderProlog$lambda($this$withPadding) {
    $this$withPadding.f2c_1 = 2;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderParameters$lambda(this$0, $parameters) {
    return function ($this$definitionList) {
      var _iterator__ex2g4s = this$0.t1p($parameters).m();
      while (_iterator__ex2g4s.n()) {
        var section = _iterator__ex2g4s.o();
        $this$definitionList.c2e(section.n1n_1, section.o1n_1);
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderOptionGroup$lambda($this$withPadding) {
    $this$withPadding.c2c_1 = 1;
    $this$withPadding.f2c_1 = 2;
    $this$withPadding.e2c_1 = 1;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderOptionGroup$lambda_0($markdown, this$0, $options) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.h2a($markdown);
      $this$verticalLayout.h2a(this$0.d1q($options));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$buildParameterList$lambda($rows, this$0) {
    return function ($this$definitionList) {
      $this$definitionList.w2d_1 = true;
      var _iterator__ex2g4s = $rows.m();
      while (_iterator__ex2g4s.n()) {
        var row = _iterator__ex2g4s.o();
        $this$definitionList.d2e(this$0.y1q(row), this$0.z1q(row));
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter(context, requiredOptionMarker, showDefaultValues, showRequiredTag) {
    requiredOptionMarker = requiredOptionMarker === VOID ? null : requiredOptionMarker;
    showDefaultValues = showDefaultValues === VOID ? false : showDefaultValues;
    showRequiredTag = showRequiredTag === VOID ? false : showRequiredTag;
    AbstractHelpFormatter.call(this, context, requiredOptionMarker, showDefaultValues, showRequiredTag);
  }
  protoOf(MordantHelpFormatter).h2f = function () {
    return get_terminal(this.u1n_1).c27_1;
  };
  protoOf(MordantHelpFormatter).r1h = function (error, prolog, epilog, parameters, programName) {
    var widget = verticalLayout(MordantHelpFormatter$formatHelp$lambda(this, error, prolog, epilog, parameters, programName));
    return get_terminal(this.u1n_1).t2d(widget);
  };
  protoOf(MordantHelpFormatter).i1o = function (parameters, error) {
    return Text_init_$Create$(this.m1o(parameters, error));
  };
  protoOf(MordantHelpFormatter).h1o = function (parameters, programName) {
    var title = this.i2f(this.f1o().t1q());
    var prog = title + ' ' + programName;
    var usageParts = this.q1o(parameters);
    var tmp;
    // Inline function 'kotlin.text.isEmpty' call
    if (charSequenceLength(usageParts) === 0) {
      tmp = Text_init_$Create$(prog, Whitespace_NORMAL_getInstance());
    } else {
      tmp = definitionList(MordantHelpFormatter$renderUsage$lambda(prog, usageParts));
    }
    return tmp;
  };
  protoOf(MordantHelpFormatter).j1o = function (prolog) {
    var tmp = this.j2f(prolog);
    return withPadding(tmp, false, MordantHelpFormatter$renderProlog$lambda);
  };
  protoOf(MordantHelpFormatter).l1o = function (epilog) {
    return this.j2f(epilog);
  };
  protoOf(MordantHelpFormatter).k1o = function (parameters) {
    return definitionList(MordantHelpFormatter$renderParameters$lambda(this, parameters));
  };
  protoOf(MordantHelpFormatter).r1p = function (help, parameters) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(parameters, 10));
    var _iterator__ex2g4s = parameters.m();
    while (_iterator__ex2g4s.n()) {
      var item = _iterator__ex2g4s.o();
      // Inline function 'com.github.ajalt.clikt.output.MordantHelpFormatter.renderOptionGroup.stub_for_inlining' call
      var tmp$ret$0 = this.w1p(item);
      destination.e(tmp$ret$0);
    }
    var options = destination;
    if (help == null)
      return this.d1q(options);
    var tmp = this.j2f(help);
    var markdown = withPadding(tmp, false, MordantHelpFormatter$renderOptionGroup$lambda);
    return verticalLayout(MordantHelpFormatter$renderOptionGroup$lambda_0(markdown, this, options));
  };
  protoOf(MordantHelpFormatter).c1o = function (name) {
    // Inline function 'kotlin.text.lowercase' call
    // Inline function 'kotlin.js.asDynamic' call
    return '<' + name.toLowerCase() + '>';
  };
  protoOf(MordantHelpFormatter).b1q = function (name) {
    return this.h2f().r26('danger').q1z(name);
  };
  protoOf(MordantHelpFormatter).k1q = function (name) {
    return this.h2f().r26('muted').q1z(name);
  };
  protoOf(MordantHelpFormatter).a1o = function (name) {
    return this.h2f().r26('info').q1z(name);
  };
  protoOf(MordantHelpFormatter).d1o = function (name) {
    return this.h2f().r26('info').q1z(name);
  };
  protoOf(MordantHelpFormatter).e1o = function (name) {
    return this.h2f().r26('info').q1z(name);
  };
  protoOf(MordantHelpFormatter).s1p = function (title) {
    return this.h2f().r26('warning').q1z(title);
  };
  protoOf(MordantHelpFormatter).i2f = function (title) {
    return this.h2f().r26('warning').q1z(title);
  };
  protoOf(MordantHelpFormatter).o1o = function (title) {
    return this.h2f().r26('danger').q1z(title);
  };
  protoOf(MordantHelpFormatter).t1o = function (parameter) {
    return this.h2f().r26('muted').q1z(parameter);
  };
  protoOf(MordantHelpFormatter).m1q = function (metavar) {
    return this.h2f().r26('warning').f23(this.h2f().r26('muted')).q1z(metavar);
  };
  protoOf(MordantHelpFormatter).y1q = function (row) {
    var tmp;
    // Inline function 'kotlin.text.isNullOrEmpty' call
    var this_0 = row.r1n_1;
    if (this_0 == null || charSequenceLength(this_0) === 0) {
      tmp = '  ';
    } else {
      // Inline function 'kotlin.text.ifEmpty' call
      var this_1 = drop('  ', ensureNotNull(row.r1n_1).length);
      var tmp_0;
      // Inline function 'kotlin.text.isEmpty' call
      if (charSequenceLength(this_1) === 0) {
        // Inline function 'com.github.ajalt.clikt.output.MordantHelpFormatter.renderDefinitionTerm.<anonymous>' call
        tmp_0 = ' ';
      } else {
        tmp_0 = this_1;
      }
      var tmp$ret$3 = tmp_0;
      tmp = plus(row.r1n_1, tmp$ret$3);
    }
    var termPrefix = tmp;
    return Text_init_$Create$(termPrefix + row.p1n_1, Whitespace_PRE_WRAP_getInstance());
  };
  protoOf(MordantHelpFormatter).z1q = function (row) {
    return isBlank(row.q1n_1) ? Text_init_$Create$('') : this.j2f(row.q1n_1);
  };
  protoOf(MordantHelpFormatter).d1q = function (rows) {
    return definitionList(MordantHelpFormatter$buildParameterList$lambda(rows, this));
  };
  protoOf(MordantHelpFormatter).j2f = function (text) {
    return Text_init_$Create$(replace(text, '\n\n', '\x85\x85'), Whitespace_NORMAL_getInstance());
  };
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = CliktCommand;
  //endregion
  return _;
}(module.exports, require('./clikt-clikt.js'), require('./kotlin-kotlin-stdlib.js'), require('./mordant-mordant.js')));

//# sourceMappingURL=clikt-clikt-mordant.js.map
